#TEMPLATE (ABC_jw, 'High KeyFields for BrowseABC'),Family('ABC')
#! =========================================================================================== !#
#! Version: 3.0                                                                                !#
#!                                                                                             !#
#! Author: Jeff Walters                                                                        !#
#! Dated : 7/07/98                                                                             !#
#! Updated : 10/3/01                                                                            !#
#! e-Mail: JeffWalters@IntelliNova.com                                                         !#
#!                                                                                             !#
#! =========================================================================================== !#
#!
#!
#! =========================================================================================== !#
#!
#EXTENSION(HigherKeys,'Set / Reset Higher Key fields'),REQ(BrowseBox(ABC)),MULTI
#!
#! =========================================================================================== !#
#!
#BUTTON('Bind / Set Fields'), AT(10,,180)
   #SHEET
   #TAB('Set Key Fields')
      #DISPLAY(''),AT(,,,2)
      #DISPLAY('Use to set / reset higher key fields of a Ranged browse.')
      #DISPLAY(''),AT(,,,2)
      #BOXED('Default Higher Key Fields')
         #DISPLAY(''),AT(,,,2)
         #BUTTON ('Set Key Fields'), MULTI(%HKFields, %TargetKeyField & ' = ' & %SettingField),INLINE, AT(,,,60)
            #DISPLAY(''),AT(,,,2)
            #BOXED('')
               #PROMPT ('Key Field:', COMPONENT(%PrimaryKey)), %TargetKeyField, REQ,AT(80,21,110)
               #PROMPT ('Parameter:', EXPR), %SettingField,AT(80,,110)
            #ENDBOXED
            #PROMPT ('Use a control to set higher key value',CHECK),%jwUseSetControl,DEFAULT(1),AT(10)
            #ENABLE(%jwUseSetControl),CLEAR
            #BOXED ('')
               #PROMPT ('Set Field Control:', CONTROL), %SettingControl
               #DISPLAY(''),AT(,,,2)
               #PROMPT ('Force ''Top Of List'' after Accepted', CHECK),%jwForceTop,DEFAULT(1),AT(10)
               #DISPLAY(''),AT(,,,2)
               #DISPLAY ('Ensures the first record of the range is always selected')
               #DISPLAY ('when a range field is changed.')
               #DISPLAY (''),AT(,,,2)
               #PROMPT ('Select another control after Accepted',CHECK),%jwSelectNextControl,DEFAULT(0),AT(10)
               #ENABLE(%jwSelectNextControl),CLEAR
                  #DISPLAY(''),AT(,,,2)
                  #PROMPT ('Control to select after Accepted',CONTROL),%SelectControl
               #ENDENABLE
            #ENDBOXED
            #ENDENABLE
         #ENDBUTTON
      #ENDBOXED
      #DISPLAY(''),AT(,,,2)
      #ENABLE(%INIActive),CLEAR
         #PROMPT ('''Remember'' last key settings in INI file:',CHECK ),%jwRememberKeys,DEFAULT(0),AT(10)
      #ENDENABLE
      #BOXED('Conditional Behaviour')
         #DISPLAY(''),AT(,,,2)
         #BUTTON('Conditional Browse Higher Key Fields'),MULTI(%HKSortOrder,%HKSortCondition & ' - ' & %HKSortKey),AT(,,,65),INLINE
            #DISPLAY(''),AT(,,,2)
            #BOXED('Conditional Behaviour')
               #DISPLAY(''),AT(,,,2)
               #PROMPT('',@S150),%HKSortCondition,AT(,,180),REQ
               #PROMPT('Key:',KEY(%Primary)),%HKSortKey,AT(35,,155),REQ
               #BUTTON ('Set Key Fields'), MULTI(%CHKFields, %CTargetKeyField & ' = ' & %CSettingField),INLINE, AT(,,,60)
                  #DISPLAY(''),AT(,,,2)
                  #BOXED('')
                     #PROMPT ('Key Field:', COMPONENT(%HKSortKey)), %CTargetKeyField, REQ,AT(80,21,110)
                     #PROMPT ('Parameter:',EXPR), %CSettingField,AT(80,,110)
                  #ENDBOXED
                  #PROMPT ('Use a control to set higher key value',CHECK),%jwCUseSetControl,DEFAULT(1),AT(10)
                  #ENABLE(%jwCUseSetControl),CLEAR
                  #BOXED ('')
                     #PROMPT ('Set Field Control:', CONTROL), %CSettingControl
                     #DISPLAY(''),AT(,,,2)
                     #PROMPT ('Force ''Top Of List'' after Accepted', CHECK),%jwCForceTop,DEFAULT(1),AT(10)
                     #DISPLAY(''),AT(,,,2)
                     #DISPLAY ('Ensures the first record of the range is always selected')
                     #DISPLAY ('when a range field is changed.')
                     #DISPLAY (''),AT(,,,2)
                     #PROMPT ('Select another control after Accepted',CHECK),%jwCSelectNextControl,DEFAULT(0),AT(10)
                     #ENABLE(%jwCSelectNextControl),CLEAR
                        #DISPLAY(''),AT(,,,2)
                        #PROMPT ('Control to select after Accepted',CONTROL),%CSelectControl
                     #ENDENABLE
                  #ENDBOXED
                  #ENDENABLE
               #ENDBUTTON
                  #PREPARE
                     #DECLARE(%CHKSortCondition,%HKSortOrder)
                     #DECLARE(%CHKSortKey,%HKSortOrder)
                     #FIX(%HKConditionalOrders,%HKSortOrder)
                     #IF(%HKRangeField AND NOT ITEMS(%CHKFields))
                        #! Ensure Higher Key Fields are set
                        #DECLARE(%CKeyFieldFound)
                        #DECLARE(%CHKNo)
                        #SET(%CHKNo,0)
                        #FIX(%File,%Primary)
                        #FIX(%Key,%HKSortKey)
                        #FOR(%KeyField)
                           #SET(%CKeyFieldFound,%False)
                           #FOR(%CHKFields)
                              #IF (%CTargetKeyField = %KeyField)
                                 #SET(%CKeyFieldFound,%True)
                                 #BREAK
                              #ENDIF
                           #ENDFOR
                           #IF (NOT %CKeyFieldFound)
                              #SET(%CHKNo,ITEMS(%CHKFields) + 1)
                              #ADD(%CHKFields,%CHKNo)
                              #SET(%CTargetKeyField,%KeyField)
                           #ENDIF
                           #IF (%KeyField = %HKRangeField)
                              #BREAK
                           #ENDIF
                        #ENDFOR
                     #ENDIF
                  #ENDPREPARE
            #ENDBOXED
         #ENDBUTTON
      #PREPARE
         #INSERT(%PrepareHigherKeyFields)
         #DECLARE(%HKConditionalOrders),Unique
         #DECLARE(%HKRangeField,%HKConditionalOrders)
         #IF(ITEMS(%SortOrder) AND NOT ITEMS(%HKSortOrder))
            #FREE(%HKConditionalOrders)
            #FOR(%SortOrder)
               #ADD(%HKSortOrder,%SortOrder)
               #SET(%HKSortCondition,%SortCondition)
               #SET(%HKSortKey,%SortKey)
               #ADD(%HKConditionalOrders,%SortOrder)
               #SET(%HKRangeField,%SortRangeField)
            #ENDFOR
         #ENDIF
      #ENDPREPARE
      #ENDBOXED
   #ENDTAB
   #TAB('Bind non-queue fields')
      #DISPLAY(''),AT(,,,2)
      #DISPLAY('Use for all fields that you wish to BIND, but where you')
      #DISPLAY('don''t want the value locked in by Browse''s queue ')
      #DISPLAY('processing (which is what the BIND option does on the')
      #DISPLAY('''Hot Fields'' tab.)')
      #DISPLAY(''),AT(,,,2)
      #BOXED('Fields To Bind')
         #DISPLAY(''),AT(,,,2)
         #BUTTON ('Set Key Fields'), MULTI(%BoundFields, %BoundField),INLINE,AT(,,,60)
            #PROMPT ('BIND Field:', EXPR), %BoundField, REQ
         #ENDBUTTON
      #ENDBOXED
   #ENDTAB
   #TAB('Usage')
      #DISPLAY(''),AT(,,,2)
      #BOXED('')
         #DISPLAY(''),AT(,,,2)
         #DISPLAY('Assuming the Browse Key with structure (KF1, KF2, KF3)')
         #DISPLAY(''),AT(,,,2)
         #DISPLAY('1 - Set Key Fields - say KF1 and KF2 - on the first tab.')
         #DISPLAY('2 - Set the Browse range field to KF2 - Current Value')
         #DISPLAY('3 - If you are using a Droplist, or parent Browse to ')
         #DISPLAY('    provide the Setting Field values, ensure that they')
         #DISPLAY('    are ''Hot'' on the Browse, or set as target fields')
         #DISPLAY('    on the Droplists.')
         #DISPLAY('4 - QED.   Enjoy! ')
      #ENDBOXED
   #ENDTAB
   #ENDSHEET
#ENDBUTTON
#! ------------------------------------------------------------------------------------------- !#
#ATSTART
#DECLARE(%jwHKListInstance)
#SET(%jwHKListInstance,%ActiveTemplateParentInstance)
#DECLARE(%jwBrowseID)
#SET(%jwBrowseID,SLICE(%InstancePrefix,1,LEN(%InstancePrefix)-1))
#DECLARE(%ListFrom)
#FIX(%Control,%ListControl)
#SET(%ListFrom,%ControlFrom)
#DECLARE(%FullSectionName)
#SET(%FullSectionName,%Procedure & '::Higher Keys')
#DECLARE(%HKTargetFields),Unique
#DECLARE(%HKTargetField,%HKTargetFields)
#!
#DECLARE(%HKSettingControls),UNIQUE
#DECLARE(%HKForceTop,%HKSettingControls)
#DECLARE(%HKSelectControl,%HKSettingControls)
#!
   #FOR(%HKSortOrder)
      #FOR(%CHKFields)
         #IF(%CSettingControl)
            #ADD(%HKSettingControls,%CSettingControl)
            #IF(%jwCForceTop)
               #SET(%HKForceTop,%TRUE)
            #ENDIF
            #IF(%CSelectControl)
               #SET(%HKSelectControl,%CSelectControl)
            #ENDIF
         #ENDIF
         #SET(%ValueConstruct,'HK' & %ActiveTemplateInstance & '::' & %CTargetKeyField)
         #ADD(%HKTargetFields,%ValueConstruct)
         #SET(%HKTargetField,%CTargetKeyField)
      #ENDFOR
   #ENDFOR
   #FOR(%HKFields)
      #IF(%SettingControl)
         #ADD(%HKSettingControls,%SettingControl)
         #IF(%jwForceTop)
            #SET(%HKForceTop,%TRUE)
         #ENDIF
         #IF(%SelectControl)
            #SET(%HKSelectControl,%SelectControl)
         #ENDIF
      #ENDIF
      #SET(%ValueConstruct,'HK' & %ActiveTemplateInstance & '::' & %TargetKeyField)
      #ADD(%HKTargetFields,%ValueConstruct)
      #SET(%HKTargetField,%TargetKeyField)
   #ENDFOR
#ENDAT
#! ------------------------------------------------------------------------------------------- !#
#AT(%DataSection),PRIORITY(3500)
                                  #CALL(%Header, 'Higher Keys')
      #FOR(%HKTargetFields)
%[25]HKTargetFields LIKE(%HKTargetField)
      #ENDFOR
                                  #CALL(%Header, 'Higher Keys')
#ENDAT
#! ------------------------------------------------------------------------------------------- !#
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(7600)
   #IF(%jwRememberKeys AND ITEMS(%HKFields))
                                  #CALL(%Header, 'Higher Keys - Last Values')
  #FOR(%HKFields)
%[15]SettingField = INIMgr.TryFetch('%FullSectionName','%SettingField')
  #ENDFOR
                                  #CALL(%Header, 'Higher Keys - Last Values')
   #ENDIF
#!
   #IF (ITEMS(%BoundFields))
                                  #CALL(%Header,'Bound Fields')
   #ENDIF
   #FOR(%BoundFields)
BIND('%BoundField',%BoundField)
   #ENDFOR
   #IF (ITEMS(%BoundFields))
                                  #CALL(%Header,'Bound Fields')
   #ENDIF
#ENDAT
#! ------------------------------------------------------------------------------------------- !#
#AT(%BrowserMethodCodeSection,%jwHKListInstance,'ApplyRange','(),BYTE'),PRIORITY(4000)
   #IF (ITEMS(%HKFields) OR ITEMS(%HKSortOrder))
                                  #CALL(%Header,'Higher Keys')
   #ENDIF
   #DECLARE(%jwKeyFieldInstance)
   #DECLARE(%HKSortSequence)
   #DECLARE(%Items)
   #FOR(%HKSortOrder)
   	  #SET(%Items,%Items + 1)
   #ENDFOR 
   #FIX(%File,%Primary)
   #IF(%Items)
      #FOR(%HKSortOrder)
	    #SET(%HKSortSequence,%HKSortSequence + 1)
         #IF(%HKSortSequence = 1)
IF %HKSortCondition
            #FIX(%Key,%HKSortKey)
            #FOR(%CHKFields)
               #FIX(%KeyField,%CTargetKeyField)
               #IF(%KeyField)
                  #SET(%jwKeyFieldInstance,INSTANCE(%KeyField))
   GET(SELF.Order.RangeList.List,%jwKeyFieldInstance)
   Self.Order.RangeList.List.Right = %CSettingField
               #ENDIF
            #ENDFOR
            #IF(%ITEMS = 1)
ELSE
               #FIX(%Key,%PrimaryKey)
               #FOR (%HKFields)
                  #FIX(%KeyField,%TargetKeyField)
                  #IF(%KeyField)
                     #SET(%jwKeyFieldInstance,INSTANCE(%KeyField))
   GET(SELF.Order.RangeList.List,%jwKeyFieldInstance)
   Self.Order.RangeList.List.Right = %SettingField
                  #ENDIF
               #ENDFOR
            #ENDIF
         #ELSIF(%HKSortSequence = %ITEMS)
ELSIF %HKSortCondition
            #FIX(%Key,%HKSortKey)
            #FOR(%CHKFields)
               #FIX(%KeyField,%CTargetKeyField)
               #IF(%KeyField)
                  #SET(%jwKeyFieldInstance,INSTANCE(%KeyField))
   GET(SELF.Order.RangeList.List,%jwKeyFieldInstance)
   Self.Order.RangeList.List.Right = %CSettingField
               #ENDIF
            #ENDFOR
ELSE
            #FIX(%Key,%PrimaryKey)
            #FOR (%HKFields)
               #FIX(%KeyField,%TargetKeyField)
               #IF(%KeyField)
                  #SET(%jwKeyFieldInstance,INSTANCE(%KeyField))
   GET(SELF.Order.RangeList.List,%jwKeyFieldInstance)
   Self.Order.RangeList.List.Right = %SettingField
               #ENDIF
            #ENDFOR
         #ELSE
ELSIF %HKSortCondition
            #FIX(%Key,%HKSortKey)
            #FOR(%CHKFields)
               #FIX(%KeyField,%CTargetKeyField)
               #IF(%KeyField)
                  #SET(%jwKeyFieldInstance,INSTANCE(%KeyField))
   GET(SELF.Order.RangeList.List,%jwKeyFieldInstance)
   Self.Order.RangeList.List.Right = %CSettingField
               #ENDIF
            #ENDFOR
         #ENDIF
      #ENDFOR
END
   #ELSE
            #FIX(%Key,%PrimaryKey)
            #FOR (%HKFields)
               #FIX(%KeyField,%TargetKeyField)
               #IF(%KeyField)
                  #SET(%jwKeyFieldInstance,INSTANCE(%KeyField))
GET(SELF.Order.RangeList.List,%jwKeyFieldInstance)
Self.Order.RangeList.List.Right = %SettingField
               #ENDIF
            #ENDFOR
   #ENDIF
   #IF (ITEMS(%HKFields) OR ITEMS(%HKSortOrder))
                                  #CALL(%Header,'Higher Keys')
   #ENDIF
#ENDAT
#! ------------------------------------------------------------------------------------------- !#
#AT(%ControlEventHandling,,'Accepted'),PRIORITY(9000)
      #IF(INLIST(%Control,%HKSettingControls) AND %ControlType <> 'SHEET')
                                  #CALL(%Header,'Higher Keys')
         #IF(%HKForceTop)
Free(%ListFrom)
         #ENDIF
%jwBrowseID.ApplyRange
%jwBrowseID.ResetSort(1)
         #IF(%HKSelectControl)
Select(%HKSelectControl)
         #ENDIF
                                  #CALL(%Header,'Higher Keys')
#!         #BREAK
      #ENDIF
#ENDAT
#! ------------------------------------------------------------------------------------------- !#
#AT(%ControlEventHandling,,'NewSelection'),PRIORITY(9000)
      #IF(INLIST(%Control,%HKSettingControls))
                                  #CALL(%Header,'Higher Keys')
         #IF(%HKForceTop)
Free(%ListFrom)
         #ENDIF
%jwBrowseID.ApplyRange
%jwBrowseID.ResetSort(1)
         #IF(%HKSelectControl)
Select(%HKSelectControl)
         #ENDIF
                                  #CALL(%Header,'Higher Keys')
         #BREAK
      #ENDIF
#ENDAT
#! ------------------------------------------------------------------------------------------- !#
#AT(%WindowManagerMethodCodeSection,'Kill','(),BYTE'),PRIORITY(9000)
   #IF(%jwRememberKeys AND ITEMS(%HKFields))
                                  #CALL(%Header, 'Higher Keys')
#FOR(%HKFields)
INIMgr.Update('%FullSectionName','%SettingField',%SettingField)
#ENDFOR
                                  #CALL(%Header, 'Higher Keys')
   #ENDIF
#ENDAT
#!
#! ------------------------------------------------------------------------------------------- !#
#GROUP(%PrepareHigherKeyFields)
#IF(%RangeField AND (NOT ITEMS(%HKFields)) AND %RangeLimitType = 'Current Value')
  #! Ensure Higher Key Fields are set
  #DECLARE(%KeyFieldFound)
  #DECLARE(%HKNo)
  #SET(%HKNo,0)
  #FIX(%File,%Primary)
  #FIX(%Key,%PrimaryKey)
  #FOR(%KeyField)
     #SET(%KeyFieldFound,%False)
     #FOR(%HKFields)
        #IF (%TargetKeyField = %KeyField)
           #SET(%KeyFieldFound,%True)
           #BREAK
        #ENDIF
     #ENDFOR
     #IF (NOT %KeyFieldFound)
        #SET(%HKNo,ITEMS(%HKFields) + 1)
        #ADD(%HKFields,%HKNo)
        #SET(%TargetKeyField,%KeyField)
     #ENDIF
     #IF (%KeyField = %RangeField)
        #BREAK
     #ENDIF
  #ENDFOR
#ENDIF
#! ------------------------------------------------------------------------------------------- !#
#GROUP(%HEADER,%HeaderDescription)
#!
#DECLARE (%HeaderLength)
#DECLARE (%LeftOfHeader)
#DECLARE (%LeftOfHeaderLength)
#DECLARE (%RightOfHeader)
#DECLARE (%RightOfHeaderLength)
#SET (%HeaderLength, LEN(%HeaderDescription))
#IF (%HeaderLength)
   #SET (%LeftOfHeaderLength, 45 - INT(%HeaderLength/2))
   #SET (%RightOfHeaderLength, 90 - %HeaderLength - %LeftOfHeaderLength)
   #SET (%LeftOfHeader, ALL('-', %LeftOfHeaderLength))
   #SET (%RightOfHeader, ALL('-', %RightOfHeaderLength))
! %LeftOfHeader %HeaderDescription %RightOfHeader !
#ELSE
   #SET (%LeftOfHeader, ALL('-', 92))
! %LeftOfHeader !
#ENDIF
#!
#! ------------------------------------------------------------------------------------------- !#
